/[gentoo-x86]/eclass/vdr-plugin.eclass
Gentoo

Diff of /eclass/vdr-plugin.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.26 Revision 1.40
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.26 2006/07/08 15:28:15 zzam Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.40 2007/01/05 17:24:19 hd_brummy Exp $
4# 4#
5# Author: 5# Author:
6# Matthias Schwarzott <zzam@gentoo.org> 6# Matthias Schwarzott <zzam@gentoo.org>
7# Joerg Bornkessel <hd_brummy@gentoo.org>
7 8
8# vdr-plugin.eclass 9# vdr-plugin.eclass
9# 10#
10# eclass to create ebuilds for vdr plugins 11# eclass to create ebuilds for vdr plugins
11# 12#
37# 38#
38# If ${VDR_RCADDON_FILE} is set install this file 39# If ${VDR_RCADDON_FILE} is set install this file
39# else install ${FILESDIR}/rc-addon.sh if it exists. 40# else install ${FILESDIR}/rc-addon.sh if it exists.
40# 41#
41# Gets installed under ${VDR_RC_DIR}/plugin-${VDRPLUGIN}.sh 42# Gets installed under ${VDR_RC_DIR}/plugin-${VDRPLUGIN}.sh
42# (in example vdr-femon this would be /usr/lib/vdr/rcscript/plugin-femon.sh) 43# (in example vdr-femon this would be /usr/share/vdr/rcscript/plugin-femon.sh)
43# 44#
44# This file is sourced by the startscript when plugin is activated in /etc/conf.d/vdr 45# This file is sourced by the startscript when plugin is activated in /etc/conf.d/vdr
45# It could be used for special startup actions for this plugins, or to create the 46# It could be used for special startup actions for this plugins, or to create the
46# plugin command line options from a nicer version of a conf.d file. 47# plugin command line options from a nicer version of a conf.d file.
47 48
49# HowTo use own local patches; Example
50#
51# Add to your /etc/make.conf:
52# VDR_LOCAL_PATCHES_DIR="/usr/local/patch"
53#
54# Add two DIR's in your local patch dir, ${PN}/${PV},
55# e.g for vdr-burn-0.1.0 should be:
56# /usr/local/patch/vdr-burn/0.1.0/
57#
58# all patches which ending on diff or patch in this DIR will automatically applied
59#
60
48inherit base multilib eutils flag-o-matic 61inherit base multilib eutils flag-o-matic
49 62
50IUSE="debug" 63IUSE=""
51 64
52# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes 65# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes
53VDRPLUGIN="${PN/#vdrplugin-/}" 66VDRPLUGIN="${PN/#vdrplugin-/}"
54VDRPLUGIN="${VDRPLUGIN/#vdr-/}" 67VDRPLUGIN="${VDRPLUGIN/#vdr-/}"
55VDRPLUGIN="${VDRPLUGIN/%-cvs/}" 68VDRPLUGIN="${VDRPLUGIN/%-cvs/}"
71 if [[ ! -f ${VDRPLUGINDB_DIR}/vdrplugindb ]]; then 84 if [[ ! -f ${VDRPLUGINDB_DIR}/vdrplugindb ]]; then
72 [[ ! -d ${VDRPLUGINDB_DIR} ]] && mkdir -p ${VDRPLUGINDB_DIR} 85 [[ ! -d ${VDRPLUGINDB_DIR} ]] && mkdir -p ${VDRPLUGINDB_DIR}
73 touch ${VDRPLUGINDB_DIR}/vdrplugindb 86 touch ${VDRPLUGINDB_DIR}/vdrplugindb
74 fi 87 fi
75 if [[ -z $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then 88 if [[ -z $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
76 einfo "Adding plugin to vdrplugindb." 89 elog "Adding plugin to vdrplugindb."
77 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> ${VDRPLUGINDB_DIR}/vdrplugindb 90 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> ${VDRPLUGINDB_DIR}/vdrplugindb
78 fi 91 fi
79} 92}
80 93
81remove_vdrplugindb() { 94remove_vdrplugindb() {
82 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/ 95 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/
83 96
84 if [[ -n $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then 97 if [[ -n $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
85 einfo "Removing ${CATEGORY}/${PN}-${PVR} from vdrplugindb." 98 elog "Removing ${CATEGORY}/${PN}-${PVR} from vdrplugindb."
86 sed -ie "/.*${CATEGORY}\/${P}.*/d" ${VDRPLUGINDB_DIR}/vdrplugindb 99 sed -ie "/.*${CATEGORY}\/${P}.*/d" ${VDRPLUGINDB_DIR}/vdrplugindb
87 fi 100 fi
101}
102
103# New method of storing plugindb
104# Called from src_install
105# file maintained by normal portage-methods
106create_plugindb_file() {
107 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
108 local DB_FILE=${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}
109 insinto ${NEW_VDRPLUGINDB_DIR}
110 cat <<-EOT > ${D}/${DB_FILE}
111 VDRPLUGIN_DB=1
112 CREATOR=ECLASS
113 EBUILD=${CATEGORY}/${PN}
114 EBUILD_V=${PVR}
115 EOT
116}
117
118# Delete files created outside of vdr-plugin.eclass
119# vdrplugin-rebuild.ebuild converted plugindb and files are
120# not deleted by portage itself - should only be needed as
121# long as not every system has switched over to
122# vdrplugin-rebuild-0.2
123delete_orphan_plugindb_file() {
124 #elog Testing for orphaned plugindb file
125 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
126 local DB_FILE=${ROOT}/${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}
127
128 # file exists
129 [[ -f ${DB_FILE} ]] || return
130
131 # will portage handle the file itself
132 if grep -q CREATOR=ECLASS ${DB_FILE}; then
133 #elog file owned by eclass - don't touch it
134 return
135 fi
136
137 elog "Removing orphaned plugindb-file."
138 elog "#rm ${DB_FILE}"
139 rm ${DB_FILE}
88} 140}
89 141
90vdr-plugin_pkg_setup() { 142vdr-plugin_pkg_setup() {
91 # -fPIC is needed for shared objects on some platforms (amd64 and others) 143 # -fPIC is needed for shared objects on some platforms (amd64 and others)
92 append-flags -fPIC 144 append-flags -fPIC
93 use debug && append-flags -g
94 145
95 # Where should the plugins live in the filesystem 146 # Where should the plugins live in the filesystem
96 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins" 147 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins"
97 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums" 148 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums"
98 149
99 # transition to /usr/share/... will need new vdr-scripts version stable 150 # was /usr/lib/... some time ago
151 # since gentoo-vdr-scripts-0.3.6 it works with /usr/share/...
100 VDR_RC_DIR="/usr/lib/vdr/rcscript" 152 VDR_RC_DIR="/usr/share/vdr/rcscript"
101 153
102 # Pathes to includes 154 # Pathes to includes
103 VDR_INCLUDE_DIR="/usr/include" 155 VDR_INCLUDE_DIR="/usr/include/vdr"
104 DVB_INCLUDE_DIR="/usr/include" 156 DVB_INCLUDE_DIR="/usr/include"
105 157
106 158
107 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/vdr/config.h) 159 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h)
108 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/vdr/config.h) 160 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h)
109 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}" 161 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
110 162
111 einfo "Building ${PF} against vdr-${VDRVERSION}" 163 elog "Building ${PF} against vdr-${VDRVERSION}"
112 einfo "APIVERSION: ${APIVERSION}" 164 elog "APIVERSION: ${APIVERSION}"
113} 165}
114 166
115vdr-plugin_src_unpack() { 167vdr-plugin_src_unpack() {
168 if [[ -z ${VDR_INCLUDE_DIR} ]]; then
169 eerror "Wrong use of vdr-plugin.eclass."
170 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup."
171 echo
172 eerror "Please report this at bugs.gentoo.org."
173 die "vdr-plugin_pkg_setup not called!"
174 fi
116 [ -z "$1" ] && vdr-plugin_src_unpack unpack patchmakefile 175 [ -z "$1" ] && vdr-plugin_src_unpack unpack add_local_patch patchmakefile
117 176
118 while [ "$1" ]; do 177 while [ "$1" ]; do
119 178
120 case "$1" in 179 case "$1" in
180 all_but_unpack)
181 vdr-plugin_src_unpack add_local_patch patchmakefile
182 ;;
121 unpack) 183 unpack)
122 base_src_unpack 184 base_src_unpack
123 ;; 185 ;;
124 patchmakefile) 186 patchmakefile)
125 if ! cd ${S}; then 187 if ! cd ${S}; then
126 ewarn "There seems to be no plugin-directory with the name ${S##*/}" 188 ewarn "There seems to be no plugin-directory with the name ${S##*/}"
127 ewarn "Perhaps you find one among these:" 189 ewarn "Perhaps you find one among these:"
128 cd "${WORKDIR}" 190 cd "${WORKDIR}"
129 einfo "$(/bin/ls -1 ${WORKDIR})" 191 elog "$(/bin/ls -1 ${WORKDIR})"
130 die "Could not change to plugin-source-directory!" 192 die "Could not change to plugin-source-directory!"
131 fi 193 fi
132 194
133 einfo "Patching Makefile" 195 elog "Patching Makefile"
134 [[ -e Makefile ]] || die "Makefile of plugin can not be found!" 196 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
135 cp Makefile Makefile.orig 197 cp Makefile Makefile.orig
136 198
137 sed -i Makefile \ 199 sed -i Makefile \
138 -e '1i\#Makefile was patched by vdr-plugin.eclass' 200 -e '1i\#Makefile was patched by vdr-plugin.eclass'
141 sed -i Makefile \ 203 sed -i Makefile \
142 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \ 204 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
143 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \ 205 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
144 -e "s:^LIBDIR.*$:LIBDIR = ${S}:" \ 206 -e "s:^LIBDIR.*$:LIBDIR = ${S}:" \
145 -e "s:^TMPDIR.*$:TMPDIR = ${T}:" \ 207 -e "s:^TMPDIR.*$:TMPDIR = ${T}:" \
208 -e 's:-I$(VDRDIR)/include -I$(DVBDIR)/include:-I$(DVBDIR)/include -I$(VDRDIR)/include:' \
146 -e 's:-I$(VDRDIR)/include:-I$(VDRDIR):' \ 209 -e 's:-I$(VDRDIR)/include:-I'"${VDR_INCLUDE_DIR%vdr}"':' \
147 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \ 210 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
148 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):' \
149 -e 's:$(VDRDIR)/\([a-z]*\.h\|Make.config\):$(VDRDIR)/vdr/\1:'
150 eend $? 211 eend $?
151 212
152 ebegin " Converting to APIVERSION" 213 ebegin " Converting to APIVERSION"
153 sed -i Makefile \ 214 sed -i Makefile \
154 -e 's:^APIVERSION = :APIVERSION ?= :' \ 215 -e 's:^APIVERSION = :APIVERSION ?= :' \
155 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \ 216 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
156 -e '2i\APIVERSION = '"${APIVERSION}" 217 -e '2i\APIVERSION = '"${APIVERSION}"
157 eend $? 218 eend $?
158 219
159 ebegin " Correcting CXXFLAGS" 220 ebegin " Correcting Compile-Flags"
160 sed -i Makefile \ 221 sed -i Makefile \
161 -e 's:^CXXFLAGS:#CXXFLAGS:' 222 -e 's:^CXXFLAGS:#CXXFLAGS:' \
223 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
162 eend $? 224 eend $?
163 225
164 ebegin " Disabling file stripping" 226 ebegin " Disabling file stripping"
165 sed -i Makefile \ 227 sed -i Makefile \
166 -e '/@.*strip/d' \ 228 -e '/@.*strip/d' \
167 -e '/strip \$(LIBDIR)\/\$@/d' \ 229 -e '/strip \$(LIBDIR)\/\$@/d' \
168 -e '/^STRIP =/d' \ 230 -e '/^STRIP =/d' \
169 -e '/@.*\$(STRIP)/d' 231 -e '/@.*\$(STRIP)/d'
170 eend $? 232 eend $?
233
234 # Use a file instead of an variable as single-stepping via ebuild
235 # destroys environment.
236 touch ${WORKDIR}/.vdr-plugin_makefile_patched
237 ;;
238 add_local_patch)
239 cd ${S}
240 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
241 echo
242 elog "Applying local patches"
243 for LOCALPATCH in ${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}/*.{diff,patch}; do
244 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
245 done
246 fi
171 ;; 247 ;;
172 esac 248 esac
173 249
174 shift 250 shift
175 done 251 done
176} 252}
177 253
178vdr-plugin_copy_source_tree() { 254vdr-plugin_copy_source_tree() {
255 pushd . >/dev/null
179 cp -r ${S} ${T}/source-tree 256 cp -r ${S} ${T}/source-tree
180 cd ${T}/source-tree 257 cd ${T}/source-tree
181 mv Makefile.orig Makefile 258 mv Makefile.orig Makefile
182 sed -i Makefile \ 259 sed -i Makefile \
183 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \ 260 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
184 -e 's:^CXXFLAGS:#CXXFLAGS:' \ 261 -e 's:^CXXFLAGS:#CXXFLAGS:' \
185 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \ 262 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
186 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):' 263 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
264 popd >/dev/null
187} 265}
188 266
189vdr-plugin_install_source_tree() { 267vdr-plugin_install_source_tree() {
190 einfo "Installing sources" 268 elog "Installing sources"
191 destdir=${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN} 269 destdir=${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}
192 insinto ${destdir}-${PV} 270 insinto ${destdir}-${PV}
193 doins -r ${T}/source-tree/* 271 doins -r ${T}/source-tree/*
194 272
195 dosym ${VDRPLUGIN}-${PV} ${destdir} 273 dosym ${VDRPLUGIN}-${PV} ${destdir}
203 case "$1" in 281 case "$1" in
204 prepare) 282 prepare)
205 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree 283 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree
206 ;; 284 ;;
207 compile) 285 compile)
286 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then
287 eerror "Wrong use of vdr-plugin.eclass."
288 eerror "An ebuild for a vdr-plugin will not work without"
289 eerror "calling vdr-plugin_src_unpack to patch the Makefile."
290 echo
291 eerror "Please report this at bugs.gentoo.org."
292 die "vdr-plugin_src_unpack not called!"
293 fi
208 cd ${S} 294 cd ${S}
209 295
210 emake ${VDRPLUGIN_MAKE_TARGET:-all} || die "emake failed" 296 emake ${BUILD_PARAMS} ${VDRPLUGIN_MAKE_TARGET:-all} || die "emake failed"
211 ;; 297 ;;
212 esac 298 esac
213 299
214 shift 300 shift
215 done 301 done
268 newins ${ROOT}${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN} 354 newins ${ROOT}${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN}
269 else 355 else
270 if which md5sum >/dev/null 2>&1; then 356 if which md5sum >/dev/null 2>&1; then
271 cd ${S} 357 cd ${S}
272 ( 358 (
273 cd ${ROOT}${VDR_INCLUDE_DIR}/vdr 359 cd ${ROOT}${VDR_INCLUDE_DIR}
274 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2 360 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
275 ) > header-md5-${PN} 361 ) > header-md5-${PN}
276 doins header-md5-${PN} 362 doins header-md5-${PN}
277 fi 363 fi
278 fi 364 fi
365
366 create_plugindb_file
279} 367}
280 368
281vdr-plugin_pkg_postinst() { 369vdr-plugin_pkg_postinst() {
370 if has_version "<=media-tv/vdrplugin-rebuild-0.1"; then
282 update_vdrplugindb 371 update_vdrplugindb
283 einfo 372 fi
373 elog
284 einfo "The vdr plugin ${VDRPLUGIN} has now been installed." 374 elog "The vdr plugin ${VDRPLUGIN} has now been installed."
285 einfo "To activate execute the following command:" 375 elog "To activate execute the following command:"
286 einfo 376 elog
287 einfo " emerge --config ${PN}" 377 elog " emerge --config ${PN}"
288 einfo 378 elog
289 if [[ -n "${VDR_CONFD_FILE}" ]]; then 379 if [[ -n "${VDR_CONFD_FILE}" ]]; then
290 einfo "And have a look at the config-file" 380 elog "And have a look at the config-file"
291 einfo "/etc/conf.d/vdr.${VDRPLUGIN}" 381 elog "/etc/conf.d/vdr.${VDRPLUGIN}"
292 einfo 382 elog
293 fi 383 fi
294} 384}
295 385
296vdr-plugin_pkg_postrm() { 386vdr-plugin_pkg_postrm() {
387 if has_version "<=media-tv/vdrplugin-rebuild-0.1"; then
297 remove_vdrplugindb 388 remove_vdrplugindb
389 fi
390 delete_orphan_plugindb_file
298} 391}
299 392
300vdr-plugin_pkg_config_final() { 393vdr-plugin_pkg_config_final() {
301 diff ${conf_orig} ${conf} 394 diff ${conf_orig} ${conf}
302 rm ${conf_orig} 395 rm ${conf_orig}
303} 396}
304 397
305vdr-plugin_pkg_config() { 398vdr-plugin_pkg_config_old() {
399 elog "Using interface of gentoo-vdr-scripts-0.3.6 and older"
306 if [[ -z "${INSTALLPLUGIN}" ]]; then 400 if [[ -z "${INSTALLPLUGIN}" ]]; then
307 INSTALLPLUGIN="${VDRPLUGIN}" 401 INSTALLPLUGIN="${VDRPLUGIN}"
308 fi 402 fi
309 # First test if plugin is already inside PLUGINS 403 # First test if plugin is already inside PLUGINS
310 local conf=/etc/conf.d/vdr 404 local conf=/etc/conf.d/vdr
311 conf_orig=${conf}.before_emerge_config 405 conf_orig=${conf}.before_emerge_config
312 cp ${conf} ${conf_orig} 406 cp ${conf} ${conf_orig}
313 407
314 einfo "Reading ${conf}" 408 elog "Reading ${conf}"
315 if ! grep -q "^PLUGINS=" ${conf}; then 409 if ! grep -q "^PLUGINS=" ${conf}; then
316 local LINE=$(sed ${conf} -n -e '/^#.*PLUGINS=/=' | tail -n 1) 410 local LINE=$(sed ${conf} -n -e '/^#.*PLUGINS=/=' | tail -n 1)
317 if [[ -n "${LINE}" ]]; then 411 if [[ -n "${LINE}" ]]; then
318 sed -e ${LINE}'a PLUGINS=""' -i ${conf} 412 sed -e ${LINE}'a PLUGINS=""' -i ${conf}
319 else 413 else
332 break; 426 break;
333 fi 427 fi
334 done 428 done
335 429
336 if [[ "${active}" == "1" ]]; then 430 if [[ "${active}" == "1" ]]; then
337 einfo "${INSTALLPLUGIN} already activated" 431 elog "${INSTALLPLUGIN} already activated"
338 echo 432 echo
339 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer 433 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
340 if [[ "${answer}" != "yes" ]]; then 434 if [[ "${answer}" != "yes" ]]; then
341 einfo "aborted" 435 elog "aborted"
342 return 436 return
343 fi 437 fi
344 einfo "Removing ${INSTALLPLUGIN} from active plugins." 438 elog "Removing ${INSTALLPLUGIN} from active plugins."
345 local LINE=$(sed ${conf} -n -e '/^PLUGINS=.*\<'${INSTALLPLUGIN}'\>/=' | tail -n 1) 439 local LINE=$(sed ${conf} -n -e '/^PLUGINS=.*\<'${INSTALLPLUGIN}'\>/=' | tail -n 1)
346 sed -i ${conf} -e ${LINE}'s/\<'${INSTALLPLUGIN}'\>//' \ 440 sed -i ${conf} -e ${LINE}'s/\<'${INSTALLPLUGIN}'\>//' \
347 -e ${LINE}'s/ \( \)*/ /g' \ 441 -e ${LINE}'s/ \( \)*/ /g' \
348 -e ${LINE}'s/ "/"/g' \ 442 -e ${LINE}'s/ "/"/g' \
349 -e ${LINE}'s/" /"/g' 443 -e ${LINE}'s/" /"/g'
351 vdr-plugin_pkg_config_final 445 vdr-plugin_pkg_config_final
352 return 446 return
353 fi 447 fi
354 448
355 449
356 einfo "Adding ${INSTALLPLUGIN} to active plugins." 450 elog "Adding ${INSTALLPLUGIN} to active plugins."
357 local LINE=$(sed ${conf} -n -e '/^PLUGINS=/=' | tail -n 1) 451 local LINE=$(sed ${conf} -n -e '/^PLUGINS=/=' | tail -n 1)
358 sed -i ${conf} -e ${LINE}'s/^PLUGINS=" *\(.*\)"/PLUGINS="\1 '${INSTALLPLUGIN}'"/' \ 452 sed -i ${conf} -e ${LINE}'s/^PLUGINS=" *\(.*\)"/PLUGINS="\1 '${INSTALLPLUGIN}'"/' \
359 -e ${LINE}'s/ \( \)*/ /g' \ 453 -e ${LINE}'s/ \( \)*/ /g' \
360 -e ${LINE}'s/ "/"/g' \ 454 -e ${LINE}'s/ "/"/g' \
361 -e ${LINE}'s/" /"/g' 455 -e ${LINE}'s/" /"/g'
362 456
363 vdr-plugin_pkg_config_final 457 vdr-plugin_pkg_config_final
364} 458}
365 459
460vdr-plugin_pkg_config_new() {
461 elog "Using interface introduced with gentoo-vdr-scripts-0.3.7"
462 if [[ -z "${INSTALLPLUGIN}" ]]; then
463 INSTALLPLUGIN="${VDRPLUGIN}"
464 fi
465
466 active=0
467 # First test if plugin is already inside PLUGINS
468 local conf=/etc/conf.d/vdr.plugins
469 exec 3<${conf}
470 while read -u 3 line; do
471 [[ ${line} == "" ]] && continue
472 [[ ${line:0:1} == "#" ]] && continue
473 set -- ${line}
474 [[ ${1} == ${INSTALLPLUGIN} ]] && active=1
475 done
476 exec 3<&-
477
478 if [[ $active == 0 ]]; then
479 elog "Adding ${INSTALLPLUGIN} to active plugins."
480
481 # The pure edit process.
482 echo "${INSTALLPLUGIN}" >> "${conf}"
483 else
484 elog "${INSTALLPLUGIN} already activated"
485 echo
486 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
487 if [[ "${answer}" != "yes" ]]; then
488 elog "aborted"
489 return
490 fi
491 elog "Removing ${INSTALLPLUGIN} from active plugins."
492
493 # The pure edit process
494 sed -i "${conf}" -e "/^[[:space:]]*${INSTALLPLUGIN}[[:space:]]*\$/d"
495 fi
496}
497
498vdr-plugin_pkg_config() {
499 if has_version ">media-tv/gentoo-vdr-scripts-0.3.6"; then
500 vdr-plugin_pkg_config_new
501 else
502 vdr-plugin_pkg_config_old
503 fi
504}
505
366fix_vdr_libsi_include() 506fix_vdr_libsi_include()
367{ 507{
368 einfo "Fixing include of libsi-headers" 508 elog "Fixing include of libsi-headers"
369 local f 509 local f
370 for f; do 510 for f; do
371 sed -i "${f}" \ 511 sed -i "${f}" \
372 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \ 512 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
373 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:' 513 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'

Legend:
Removed from v.1.26  
changed lines
  Added in v.1.40

  ViewVC Help
Powered by ViewVC 1.1.20